/*
{
  "IMPORTED" : [
    {
      "NAME" : "iChannel1",
      "PATH" : "square.1d6177f5.png"
    },
    {
      "NAME" : "iChannel2",
      "PATH" : "spiral-3.9f8562dc.png"
    },
    {
      "NAME" : "iChannel3",
      "PATH" : "spiral-2.3aacc1b8.png"
    },
    {
      "NAME" : "iChannel4",
      "PATH" : "spiral-1.a78bc91a.png"
    },
    {
      "NAME" : "iChannel5",
      "PATH" : "radial-tri-lateral-4.7db1e0b6.png"
    },
    {
      "NAME" : "iChannel6",
      "PATH" : "linear-sawtooth-lateral-4.841b7ad8.png"
    },
    {
      "NAME" : "iChannel7",
      "PATH" : "conical-sym.853269ea.png"
    },
    {
      "NAME" : "iChannel8",
      "PATH" : "conical-asym.3aa272c0.png"
    },
    {
      "NAME" : "iChannel9",
      "PATH" : "bilinear-lateral.165c3f2b.png"
    }
  ],
  "CATEGORIES" : [
    "Automatically Converted",
    "Transitions"
  ],
  "DESCRIPTION" : "Automatically converted from https:\/\/www.shadertoy.com\/view\/Xl3BDn by hezhk3.  see https:\/\/gl-transitions.com\/editor\/windowslice",
  "INPUTS" : [
    {
      "TYPE" : "image",
      "NAME" : "inputImage"
    },
    {
      "TYPE" : "image",
      "NAME" : "iChannel0"
    },
    {
      "LABELS" : [
        "square",
        "spiral1",
        "spiral2",
        "spiral3",
        "radial",
        "conical1",
        "conical2",
        "biliniar"
      ],
      "NAME" : "longInputIsPopUpButton",
      "TYPE" : "long",
      "VALUES" : [
        0,
        1,
        2,
        3,
        4,
        5,
        6,
        7,
        8
      ]
    }
  ],
  "ISFVSN" : "2"
}
*/


#define texture2D(a,b) texture(a,b)

#define textureCoordinate (gl_FragCoord.xy / RENDERSIZE.xy)
#define textureCoordinate2 (gl_FragCoord.xy / RENDERSIZE.xy)

#define progress fract(TIME*0.5)
#define ratio (RENDERSIZE.x / RENDERSIZE.y)

#define REV_VEC2(p) vec2(p.x, 1.0 - p.y)
#define getFromColor(coord) IMG_NORM_PIXEL(inputImage, REV_VEC2(coord))
#define getToColor(coord) IMG_NORM_PIXEL(iChannel0, REV_VEC2(coord))

float strength= 0.5; // = 0.5

vec4 transition (vec2 uv) {
	float displacement;
  if (longInputIsPopUpButton == 0)
   displacement = IMG_NORM_PIXEL(iChannel1, uv).r * strength;
  if (longInputIsPopUpButton == 1)
   displacement = IMG_NORM_PIXEL(iChannel2, uv).r * strength;
   if (longInputIsPopUpButton == 2)
   displacement = IMG_NORM_PIXEL(iChannel3, uv).r * strength;
if (longInputIsPopUpButton == 3)
   displacement = IMG_NORM_PIXEL(iChannel4, uv).r * strength;
if (longInputIsPopUpButton == 4)
   displacement = IMG_NORM_PIXEL(iChannel5, uv).r * strength;
if (longInputIsPopUpButton == 5)
   displacement = IMG_NORM_PIXEL(iChannel6, uv).r * strength;
if (longInputIsPopUpButton == 6)
   displacement = IMG_NORM_PIXEL(iChannel7, uv).r * strength;
if (longInputIsPopUpButton == 7)
   displacement = IMG_NORM_PIXEL(iChannel8, uv).r * strength;
   if (longInputIsPopUpButton == 8)
   displacement = IMG_NORM_PIXEL(iChannel9, uv).r * strength;



  vec2 uvFrom = vec2(uv.x + progress * displacement, uv.y);
  vec2 uvTo = vec2(uv.x - (1.0 - progress) * displacement, uv.y);

  return mix(
    getFromColor(uvFrom),
    getToColor(uvTo),
    progress
  );
}
void main() {
	
    gl_FragColor = 	transition(REV_VEC2(textureCoordinate));



	
}
