/*
{
  "IMPORTED" : [

  ],
  "CATEGORIES" : [
    "Automatically Converted",
    "Transitions"
  ],
  "DESCRIPTION" : "Automatically converted from https:\/\/www.shadertoy.com\/view\/Xl3BDn by hezhk3.  see https:\/\/gl-transitions.com\/editor\/windowslice",
  "INPUTS" : [
    {
      "TYPE" : "image",
      "NAME" : "inputImage"
    },
    {
      "TYPE" : "image",
      "NAME" : "iChannel0"
    }
  ],
  "ISFVSN" : "2"
}
*/


#define texture2D(a,b) texture(a,b)

#define textureCoordinate (gl_FragCoord.xy / RENDERSIZE.xy)
#define textureCoordinate2 (gl_FragCoord.xy / RENDERSIZE.xy)

#define progress fract(TIME*0.5)
#define ratio (RENDERSIZE.x / RENDERSIZE.y)

#define REV_VEC2(p) vec2(p.x, 1.0 - p.y)
#define getFromColor(coord) IMG_NORM_PIXEL(inputImage, REV_VEC2(coord))
#define getToColor(coord) IMG_NORM_PIXEL(iChannel0, REV_VEC2(coord))

vec2 offset2(float progress2, float x, float theta) {
  float phase = progress2*progress2 + progress2 + theta;
  float shifty = 0.03*progress2*cos(10.0*(progress2+x));
  return vec2(0, shifty);
}
vec4 transition(vec2 p) {
	vec2 k=p + offset2(progress, p.x, 0.0);
	vec2 k2=p + offset2(1.0-progress, p.x, 3.14);
  return mix(getFromColor(k), getToColor(k2), progress);
}


void main() {



    gl_FragColor = transition(REV_VEC2(textureCoordinate));
}
