/*
{
  "IMPORTED" : [

  ],
  "CATEGORIES" : [
    "Automatically Converted",
    "Transitions"
  ],
  "DESCRIPTION" : "Automatically converted from https:\/\/www.shadertoy.com\/view\/Xl3BDn by hezhk3.  see https:\/\/gl-transitions.com\/editor\/windowslice",
  "INPUTS" : [
    {
      "TYPE" : "image",
      "NAME" : "inputImage"
    },
    {
      "TYPE" : "image",
      "NAME" : "iChannel0"
    }
  ],
  "ISFVSN" : "2"
}
*/


#define texture2D(a,b) texture(a,b)

#define textureCoordinate (gl_FragCoord.xy / RENDERSIZE.xy)
#define textureCoordinate2 (gl_FragCoord.xy / RENDERSIZE.xy)

#define progress fract(TIME*0.5)
#define ratio (RENDERSIZE.x / RENDERSIZE.y)

#define REV_VEC2(p) vec2(p.x, 1.0 - p.y)
#define getFromColor(coord) IMG_NORM_PIXEL(inputImage, REV_VEC2(coord))
#define getToColor(coord) IMG_NORM_PIXEL(iChannel0, REV_VEC2(coord))

 float smoothness= 0.3; // = 0.3
 bool opening= true
; // = true

const vec2 center = vec2(0.5, 0.5);
const float SQRT_2 = 1.414213562373;

vec4 transition (vec2 uv) {
  float x = opening ? progress : 1.-progress;
  float m = smoothstep(-smoothness, 0.0, SQRT_2*distance(center, uv) - x*(1.+smoothness));
  return mix(getFromColor(uv), getToColor(uv), opening ? 1.-m : m);
}


void main() {



    gl_FragColor = transition(REV_VEC2(textureCoordinate));
}
