/*
{
  "IMPORTED" : [

  ],
  "CATEGORIES" : [
    "Automatically Converted",
    "Transitions"
  ],
  "DESCRIPTION" : "Automatically converted from https:\/\/www.shadertoy.com\/view\/Xl3BDn by hezhk3.  see https:\/\/gl-transitions.com\/editor\/windowslice",
  "INPUTS" : [
    {
      "TYPE" : "image",
      "NAME" : "inputImage"
    },
    {
      "TYPE" : "image",
      "NAME" : "iChannel0"
    }
  ],
  "ISFVSN" : "2"
}
*/


#define texture2D(a,b) texture(a,b)

#define textureCoordinate (gl_FragCoord.xy / RENDERSIZE.xy)
#define textureCoordinate2 (gl_FragCoord.xy / RENDERSIZE.xy)

#define progress fract(TIME*0.5)
#define ratio (RENDERSIZE.x / RENDERSIZE.y)

#define REV_VEC2(p) vec2(p.x, 1.0 - p.y)
#define getFromColor(coord) IMG_NORM_PIXEL(inputImage, REV_VEC2(coord))
#define getToColor(coord) IMG_NORM_PIXEL(iChannel0, REV_VEC2(coord))

 vec2 squares= vec2(10,10);// = ivec2(10,10)
 vec2 direction= vec2(1.0, -0.5);// = vec2(1.0, -0.5)
 float smoothness= 1.6; // = 1.6

const vec2 center = vec2(0.5, 0.5);
vec4 transition (vec2 p) {
  vec2 v = normalize(direction);
  v /= abs(v.x)+abs(v.y);
  float d = v.x * center.x + v.y * center.y;
  float offset = smoothness;
  float pr = smoothstep(-offset, 0.0, v.x * p.x + v.y * p.y - (d-0.5+progress*(1.+offset)));
  vec2 squarep = fract(p*vec2(squares));
  vec2 squaremin = vec2(pr/2.0);
  vec2 squaremax = vec2(1.0 - pr/2.0);
  float a = (1.0 - step(progress, 0.0)) * step(squaremin.x, squarep.x) * step(squaremin.y, squarep.y) * step(squarep.x, squaremax.x) * step(squarep.y, squaremax.y);
  return mix(getFromColor(p), getToColor(p), a);
}

void main() {



    gl_FragColor = transition(REV_VEC2(textureCoordinate));
}
