/*
{
  "IMPORTED" : [

  ],
  "CATEGORIES" : [
    "Automatically Converted",
    "Transitions"
  ],
  "DESCRIPTION" : "Automatically converted from https:\/\/www.shadertoy.com\/view\/Xl3BDn by hezhk3.  see https:\/\/gl-transitions.com\/editor\/windowslice",
  "INPUTS" : [
    {
      "TYPE" : "image",
      "NAME" : "inputImage"
    },
    {
      "TYPE" : "image",
      "NAME" : "iChannel0"
    }
  ],
  "ISFVSN" : "2"
}
*/


#define texture2D(a,b) texture(a,b)

#define textureCoordinate (gl_FragCoord.xy / RENDERSIZE.xy)
#define textureCoordinate2 (gl_FragCoord.xy / RENDERSIZE.xy)

#define progress fract(TIME*0.5)
#define ratio (RENDERSIZE.x / RENDERSIZE.y)

#define REV_VEC2(p) vec2(p.x, 1.0 - p.y)
#define getFromColor(coord) IMG_NORM_PIXEL(inputImage, REV_VEC2(coord))
#define getToColor(coord) IMG_NORM_PIXEL(iChannel0, REV_VEC2(coord))

 float amplitude= 1.0; // = 1.0
 float waves= 30.0; // = 30.0
 float colorSeparation= 0.3; // = 0.3
float PI = 3.14159265358979323846264;
float compute(vec2 p, float progress2, vec2 center) {
vec2 o = p*sin(progress2 * amplitude)-center;
// horizontal vector
vec2 h = vec2(1., 0.);
// butterfly polar function (don't ask me why this one :))
float theta = acos(dot(o, h)) * waves;
return (exp(cos(theta)) - 2.*cos(4.*theta) + pow(sin((2.*theta - PI) / 24.), 5.)) / 10.;
}
vec4 transition(vec2 uv) {
  vec2 p = uv.xy / vec2(1.0).xy;
  float inv = 1. - progress;
  vec2 dir = p - vec2(.5);
  float dist = length(dir);
  float disp = compute(p, progress, vec2(0.5, 0.5)) ;
  vec2 k=p + inv*disp;
  vec4 texTo = getToColor(k);
  vec2 k2=p + progress*disp*(1.0 - colorSeparation);
  vec2 k3= p + progress*disp;
  vec2 k4=p + progress*disp*(1.0 + colorSeparation);
  vec4 texFrom = vec4(
  getFromColor(k2).r,
  getFromColor(k3).g,
  getFromColor(k4).b,
  1.0);
  return texTo*progress + texFrom*inv;
}
void main() {



    gl_FragColor = transition(REV_VEC2(textureCoordinate));
}
